"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListTagsForResourceResponse = exports.ListTagsForResourceRequest = exports.ListScheduledQueriesResponse = exports.ScheduledQuery = exports.TargetDestination = exports.TimestreamDestination = exports.ListScheduledQueriesRequest = exports.ExecuteScheduledQueryRequest = exports.DescribeScheduledQueryResponse = exports.ScheduledQueryDescription = exports.ScheduledQueryState = exports.ScheduledQueryRunSummary = exports.ScheduledQueryRunStatus = exports.ExecutionStats = exports.ErrorReportLocation = exports.S3ReportLocation = exports.DescribeScheduledQueryRequest = exports.DescribeEndpointsResponse = exports.Endpoint = exports.DescribeEndpointsRequest = exports.ResourceNotFoundException = exports.DeleteScheduledQueryRequest = exports.ServiceQuotaExceededException = exports.CreateScheduledQueryResponse = exports.CreateScheduledQueryRequest = exports.TargetConfiguration = exports.TimestreamConfiguration = exports.MultiMeasureMappings = exports.MixedMeasureMapping = exports.MultiMeasureAttributeMapping = exports.ScalarMeasureValueType = exports.MeasureValueType = exports.DimensionMapping = exports.DimensionValueType = exports.Tag = exports.ScheduleConfiguration = exports.NotificationConfiguration = exports.SnsConfiguration = exports.ErrorReportConfiguration = exports.S3Configuration = exports.S3EncryptionOption = exports.ConflictException = exports.ScalarType = exports.ValidationException = exports.ThrottlingException = exports.InvalidEndpointException = exports.InternalServerException = exports.CancelQueryResponse = exports.CancelQueryRequest = exports.AccessDeniedException = void 0;
exports.PrepareQueryResponse = exports.QueryResponse = exports.Row = exports.TimeSeriesDataPoint = exports.SelectColumn = exports.ParameterMapping = exports.Datum = exports.Type = exports.ColumnInfo = exports.UpdateScheduledQueryRequest = exports.UntagResourceResponse = exports.UntagResourceRequest = exports.TagResourceResponse = exports.TagResourceRequest = exports.QueryStatus = exports.QueryRequest = exports.QueryExecutionException = exports.PrepareQueryRequest = void 0;
const smithy_client_1 = require("@aws-sdk/smithy-client");
const TimestreamQueryServiceException_1 = require("./TimestreamQueryServiceException");
class AccessDeniedException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "AccessDeniedException",
            $fault: "client",
            ...opts,
        });
        this.name = "AccessDeniedException";
        this.$fault = "client";
        Object.setPrototypeOf(this, AccessDeniedException.prototype);
        this.Message = opts.Message;
    }
}
exports.AccessDeniedException = AccessDeniedException;
var CancelQueryRequest;
(function (CancelQueryRequest) {
    CancelQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CancelQueryRequest = exports.CancelQueryRequest || (exports.CancelQueryRequest = {}));
var CancelQueryResponse;
(function (CancelQueryResponse) {
    CancelQueryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CancelQueryResponse = exports.CancelQueryResponse || (exports.CancelQueryResponse = {}));
class InternalServerException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "InternalServerException",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServerException";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServerException.prototype);
        this.Message = opts.Message;
    }
}
exports.InternalServerException = InternalServerException;
class InvalidEndpointException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "InvalidEndpointException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidEndpointException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidEndpointException.prototype);
        this.Message = opts.Message;
    }
}
exports.InvalidEndpointException = InvalidEndpointException;
class ThrottlingException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "ThrottlingException",
            $fault: "client",
            ...opts,
        });
        this.name = "ThrottlingException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ThrottlingException.prototype);
        this.Message = opts.Message;
    }
}
exports.ThrottlingException = ThrottlingException;
class ValidationException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "ValidationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ValidationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ValidationException.prototype);
        this.Message = opts.Message;
    }
}
exports.ValidationException = ValidationException;
var ScalarType;
(function (ScalarType) {
    ScalarType["BIGINT"] = "BIGINT";
    ScalarType["BOOLEAN"] = "BOOLEAN";
    ScalarType["DATE"] = "DATE";
    ScalarType["DOUBLE"] = "DOUBLE";
    ScalarType["INTEGER"] = "INTEGER";
    ScalarType["INTERVAL_DAY_TO_SECOND"] = "INTERVAL_DAY_TO_SECOND";
    ScalarType["INTERVAL_YEAR_TO_MONTH"] = "INTERVAL_YEAR_TO_MONTH";
    ScalarType["TIME"] = "TIME";
    ScalarType["TIMESTAMP"] = "TIMESTAMP";
    ScalarType["UNKNOWN"] = "UNKNOWN";
    ScalarType["VARCHAR"] = "VARCHAR";
})(ScalarType = exports.ScalarType || (exports.ScalarType = {}));
class ConflictException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "ConflictException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConflictException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConflictException.prototype);
        this.Message = opts.Message;
    }
}
exports.ConflictException = ConflictException;
var S3EncryptionOption;
(function (S3EncryptionOption) {
    S3EncryptionOption["SSE_KMS"] = "SSE_KMS";
    S3EncryptionOption["SSE_S3"] = "SSE_S3";
})(S3EncryptionOption = exports.S3EncryptionOption || (exports.S3EncryptionOption = {}));
var S3Configuration;
(function (S3Configuration) {
    S3Configuration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3Configuration = exports.S3Configuration || (exports.S3Configuration = {}));
var ErrorReportConfiguration;
(function (ErrorReportConfiguration) {
    ErrorReportConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ErrorReportConfiguration = exports.ErrorReportConfiguration || (exports.ErrorReportConfiguration = {}));
var SnsConfiguration;
(function (SnsConfiguration) {
    SnsConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SnsConfiguration = exports.SnsConfiguration || (exports.SnsConfiguration = {}));
var NotificationConfiguration;
(function (NotificationConfiguration) {
    NotificationConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(NotificationConfiguration = exports.NotificationConfiguration || (exports.NotificationConfiguration = {}));
var ScheduleConfiguration;
(function (ScheduleConfiguration) {
    ScheduleConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ScheduleConfiguration = exports.ScheduleConfiguration || (exports.ScheduleConfiguration = {}));
var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Tag = exports.Tag || (exports.Tag = {}));
var DimensionValueType;
(function (DimensionValueType) {
    DimensionValueType["VARCHAR"] = "VARCHAR";
})(DimensionValueType = exports.DimensionValueType || (exports.DimensionValueType = {}));
var DimensionMapping;
(function (DimensionMapping) {
    DimensionMapping.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DimensionMapping = exports.DimensionMapping || (exports.DimensionMapping = {}));
var MeasureValueType;
(function (MeasureValueType) {
    MeasureValueType["BIGINT"] = "BIGINT";
    MeasureValueType["BOOLEAN"] = "BOOLEAN";
    MeasureValueType["DOUBLE"] = "DOUBLE";
    MeasureValueType["MULTI"] = "MULTI";
    MeasureValueType["VARCHAR"] = "VARCHAR";
})(MeasureValueType = exports.MeasureValueType || (exports.MeasureValueType = {}));
var ScalarMeasureValueType;
(function (ScalarMeasureValueType) {
    ScalarMeasureValueType["BIGINT"] = "BIGINT";
    ScalarMeasureValueType["BOOLEAN"] = "BOOLEAN";
    ScalarMeasureValueType["DOUBLE"] = "DOUBLE";
    ScalarMeasureValueType["TIMESTAMP"] = "TIMESTAMP";
    ScalarMeasureValueType["VARCHAR"] = "VARCHAR";
})(ScalarMeasureValueType = exports.ScalarMeasureValueType || (exports.ScalarMeasureValueType = {}));
var MultiMeasureAttributeMapping;
(function (MultiMeasureAttributeMapping) {
    MultiMeasureAttributeMapping.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MultiMeasureAttributeMapping = exports.MultiMeasureAttributeMapping || (exports.MultiMeasureAttributeMapping = {}));
var MixedMeasureMapping;
(function (MixedMeasureMapping) {
    MixedMeasureMapping.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MixedMeasureMapping = exports.MixedMeasureMapping || (exports.MixedMeasureMapping = {}));
var MultiMeasureMappings;
(function (MultiMeasureMappings) {
    MultiMeasureMappings.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(MultiMeasureMappings = exports.MultiMeasureMappings || (exports.MultiMeasureMappings = {}));
var TimestreamConfiguration;
(function (TimestreamConfiguration) {
    TimestreamConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TimestreamConfiguration = exports.TimestreamConfiguration || (exports.TimestreamConfiguration = {}));
var TargetConfiguration;
(function (TargetConfiguration) {
    TargetConfiguration.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TargetConfiguration = exports.TargetConfiguration || (exports.TargetConfiguration = {}));
var CreateScheduledQueryRequest;
(function (CreateScheduledQueryRequest) {
    CreateScheduledQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.QueryString && { QueryString: smithy_client_1.SENSITIVE_STRING }),
        ...(obj.ClientToken && { ClientToken: smithy_client_1.SENSITIVE_STRING }),
    });
})(CreateScheduledQueryRequest = exports.CreateScheduledQueryRequest || (exports.CreateScheduledQueryRequest = {}));
var CreateScheduledQueryResponse;
(function (CreateScheduledQueryResponse) {
    CreateScheduledQueryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(CreateScheduledQueryResponse = exports.CreateScheduledQueryResponse || (exports.CreateScheduledQueryResponse = {}));
class ServiceQuotaExceededException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "ServiceQuotaExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "ServiceQuotaExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ServiceQuotaExceededException.prototype);
        this.Message = opts.Message;
    }
}
exports.ServiceQuotaExceededException = ServiceQuotaExceededException;
var DeleteScheduledQueryRequest;
(function (DeleteScheduledQueryRequest) {
    DeleteScheduledQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DeleteScheduledQueryRequest = exports.DeleteScheduledQueryRequest || (exports.DeleteScheduledQueryRequest = {}));
class ResourceNotFoundException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.Message = opts.Message;
        this.ScheduledQueryArn = opts.ScheduledQueryArn;
    }
}
exports.ResourceNotFoundException = ResourceNotFoundException;
var DescribeEndpointsRequest;
(function (DescribeEndpointsRequest) {
    DescribeEndpointsRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeEndpointsRequest = exports.DescribeEndpointsRequest || (exports.DescribeEndpointsRequest = {}));
var Endpoint;
(function (Endpoint) {
    Endpoint.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Endpoint = exports.Endpoint || (exports.Endpoint = {}));
var DescribeEndpointsResponse;
(function (DescribeEndpointsResponse) {
    DescribeEndpointsResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeEndpointsResponse = exports.DescribeEndpointsResponse || (exports.DescribeEndpointsResponse = {}));
var DescribeScheduledQueryRequest;
(function (DescribeScheduledQueryRequest) {
    DescribeScheduledQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(DescribeScheduledQueryRequest = exports.DescribeScheduledQueryRequest || (exports.DescribeScheduledQueryRequest = {}));
var S3ReportLocation;
(function (S3ReportLocation) {
    S3ReportLocation.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(S3ReportLocation = exports.S3ReportLocation || (exports.S3ReportLocation = {}));
var ErrorReportLocation;
(function (ErrorReportLocation) {
    ErrorReportLocation.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ErrorReportLocation = exports.ErrorReportLocation || (exports.ErrorReportLocation = {}));
var ExecutionStats;
(function (ExecutionStats) {
    ExecutionStats.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ExecutionStats = exports.ExecutionStats || (exports.ExecutionStats = {}));
var ScheduledQueryRunStatus;
(function (ScheduledQueryRunStatus) {
    ScheduledQueryRunStatus["AUTO_TRIGGER_FAILURE"] = "AUTO_TRIGGER_FAILURE";
    ScheduledQueryRunStatus["AUTO_TRIGGER_SUCCESS"] = "AUTO_TRIGGER_SUCCESS";
    ScheduledQueryRunStatus["MANUAL_TRIGGER_FAILURE"] = "MANUAL_TRIGGER_FAILURE";
    ScheduledQueryRunStatus["MANUAL_TRIGGER_SUCCESS"] = "MANUAL_TRIGGER_SUCCESS";
})(ScheduledQueryRunStatus = exports.ScheduledQueryRunStatus || (exports.ScheduledQueryRunStatus = {}));
var ScheduledQueryRunSummary;
(function (ScheduledQueryRunSummary) {
    ScheduledQueryRunSummary.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ScheduledQueryRunSummary = exports.ScheduledQueryRunSummary || (exports.ScheduledQueryRunSummary = {}));
var ScheduledQueryState;
(function (ScheduledQueryState) {
    ScheduledQueryState["DISABLED"] = "DISABLED";
    ScheduledQueryState["ENABLED"] = "ENABLED";
})(ScheduledQueryState = exports.ScheduledQueryState || (exports.ScheduledQueryState = {}));
var ScheduledQueryDescription;
(function (ScheduledQueryDescription) {
    ScheduledQueryDescription.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.QueryString && { QueryString: smithy_client_1.SENSITIVE_STRING }),
    });
})(ScheduledQueryDescription = exports.ScheduledQueryDescription || (exports.ScheduledQueryDescription = {}));
var DescribeScheduledQueryResponse;
(function (DescribeScheduledQueryResponse) {
    DescribeScheduledQueryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.ScheduledQuery && { ScheduledQuery: ScheduledQueryDescription.filterSensitiveLog(obj.ScheduledQuery) }),
    });
})(DescribeScheduledQueryResponse = exports.DescribeScheduledQueryResponse || (exports.DescribeScheduledQueryResponse = {}));
var ExecuteScheduledQueryRequest;
(function (ExecuteScheduledQueryRequest) {
    ExecuteScheduledQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.ClientToken && { ClientToken: smithy_client_1.SENSITIVE_STRING }),
    });
})(ExecuteScheduledQueryRequest = exports.ExecuteScheduledQueryRequest || (exports.ExecuteScheduledQueryRequest = {}));
var ListScheduledQueriesRequest;
(function (ListScheduledQueriesRequest) {
    ListScheduledQueriesRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListScheduledQueriesRequest = exports.ListScheduledQueriesRequest || (exports.ListScheduledQueriesRequest = {}));
var TimestreamDestination;
(function (TimestreamDestination) {
    TimestreamDestination.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TimestreamDestination = exports.TimestreamDestination || (exports.TimestreamDestination = {}));
var TargetDestination;
(function (TargetDestination) {
    TargetDestination.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TargetDestination = exports.TargetDestination || (exports.TargetDestination = {}));
var ScheduledQuery;
(function (ScheduledQuery) {
    ScheduledQuery.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ScheduledQuery = exports.ScheduledQuery || (exports.ScheduledQuery = {}));
var ListScheduledQueriesResponse;
(function (ListScheduledQueriesResponse) {
    ListScheduledQueriesResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListScheduledQueriesResponse = exports.ListScheduledQueriesResponse || (exports.ListScheduledQueriesResponse = {}));
var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceRequest = exports.ListTagsForResourceRequest || (exports.ListTagsForResourceRequest = {}));
var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ListTagsForResourceResponse = exports.ListTagsForResourceResponse || (exports.ListTagsForResourceResponse = {}));
var PrepareQueryRequest;
(function (PrepareQueryRequest) {
    PrepareQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.QueryString && { QueryString: smithy_client_1.SENSITIVE_STRING }),
    });
})(PrepareQueryRequest = exports.PrepareQueryRequest || (exports.PrepareQueryRequest = {}));
class QueryExecutionException extends TimestreamQueryServiceException_1.TimestreamQueryServiceException {
    constructor(opts) {
        super({
            name: "QueryExecutionException",
            $fault: "client",
            ...opts,
        });
        this.name = "QueryExecutionException";
        this.$fault = "client";
        Object.setPrototypeOf(this, QueryExecutionException.prototype);
        this.Message = opts.Message;
    }
}
exports.QueryExecutionException = QueryExecutionException;
var QueryRequest;
(function (QueryRequest) {
    QueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.QueryString && { QueryString: smithy_client_1.SENSITIVE_STRING }),
        ...(obj.ClientToken && { ClientToken: smithy_client_1.SENSITIVE_STRING }),
    });
})(QueryRequest = exports.QueryRequest || (exports.QueryRequest = {}));
var QueryStatus;
(function (QueryStatus) {
    QueryStatus.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(QueryStatus = exports.QueryStatus || (exports.QueryStatus = {}));
var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceRequest = exports.TagResourceRequest || (exports.TagResourceRequest = {}));
var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TagResourceResponse = exports.TagResourceResponse || (exports.TagResourceResponse = {}));
var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceRequest = exports.UntagResourceRequest || (exports.UntagResourceRequest = {}));
var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UntagResourceResponse = exports.UntagResourceResponse || (exports.UntagResourceResponse = {}));
var UpdateScheduledQueryRequest;
(function (UpdateScheduledQueryRequest) {
    UpdateScheduledQueryRequest.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(UpdateScheduledQueryRequest = exports.UpdateScheduledQueryRequest || (exports.UpdateScheduledQueryRequest = {}));
var ColumnInfo;
(function (ColumnInfo) {
    ColumnInfo.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ColumnInfo = exports.ColumnInfo || (exports.ColumnInfo = {}));
var Type;
(function (Type) {
    Type.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Type = exports.Type || (exports.Type = {}));
var Datum;
(function (Datum) {
    Datum.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Datum = exports.Datum || (exports.Datum = {}));
var ParameterMapping;
(function (ParameterMapping) {
    ParameterMapping.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(ParameterMapping = exports.ParameterMapping || (exports.ParameterMapping = {}));
var SelectColumn;
(function (SelectColumn) {
    SelectColumn.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(SelectColumn = exports.SelectColumn || (exports.SelectColumn = {}));
var TimeSeriesDataPoint;
(function (TimeSeriesDataPoint) {
    TimeSeriesDataPoint.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(TimeSeriesDataPoint = exports.TimeSeriesDataPoint || (exports.TimeSeriesDataPoint = {}));
var Row;
(function (Row) {
    Row.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(Row = exports.Row || (exports.Row = {}));
var QueryResponse;
(function (QueryResponse) {
    QueryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
    });
})(QueryResponse = exports.QueryResponse || (exports.QueryResponse = {}));
var PrepareQueryResponse;
(function (PrepareQueryResponse) {
    PrepareQueryResponse.filterSensitiveLog = (obj) => ({
        ...obj,
        ...(obj.QueryString && { QueryString: smithy_client_1.SENSITIVE_STRING }),
    });
})(PrepareQueryResponse = exports.PrepareQueryResponse || (exports.PrepareQueryResponse = {}));
