import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateScheduledQueryRequest, CreateScheduledQueryResponse } from "../models/models_0";
import { deserializeAws_json1_0CreateScheduledQueryCommand, serializeAws_json1_0CreateScheduledQueryCommand, } from "../protocols/Aws_json1_0";
var CreateScheduledQueryCommand = (function (_super) {
    __extends(CreateScheduledQueryCommand, _super);
    function CreateScheduledQueryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateScheduledQueryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamQueryClient";
        var commandName = "CreateScheduledQueryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateScheduledQueryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateScheduledQueryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateScheduledQueryCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0CreateScheduledQueryCommand(input, context);
    };
    CreateScheduledQueryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0CreateScheduledQueryCommand(output, context);
    };
    return CreateScheduledQueryCommand;
}($Command));
export { CreateScheduledQueryCommand };
