import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ExecuteScheduledQueryRequest } from "../models/models_0";
import { deserializeAws_json1_0ExecuteScheduledQueryCommand, serializeAws_json1_0ExecuteScheduledQueryCommand, } from "../protocols/Aws_json1_0";
var ExecuteScheduledQueryCommand = (function (_super) {
    __extends(ExecuteScheduledQueryCommand, _super);
    function ExecuteScheduledQueryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ExecuteScheduledQueryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamQueryClient";
        var commandName = "ExecuteScheduledQueryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ExecuteScheduledQueryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ExecuteScheduledQueryCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0ExecuteScheduledQueryCommand(input, context);
    };
    ExecuteScheduledQueryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0ExecuteScheduledQueryCommand(output, context);
    };
    return ExecuteScheduledQueryCommand;
}($Command));
export { ExecuteScheduledQueryCommand };
