import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListScheduledQueriesRequest, ListScheduledQueriesResponse } from "../models/models_0";
import { deserializeAws_json1_0ListScheduledQueriesCommand, serializeAws_json1_0ListScheduledQueriesCommand, } from "../protocols/Aws_json1_0";
var ListScheduledQueriesCommand = (function (_super) {
    __extends(ListScheduledQueriesCommand, _super);
    function ListScheduledQueriesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListScheduledQueriesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamQueryClient";
        var commandName = "ListScheduledQueriesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListScheduledQueriesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListScheduledQueriesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListScheduledQueriesCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0ListScheduledQueriesCommand(input, context);
    };
    ListScheduledQueriesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0ListScheduledQueriesCommand(output, context);
    };
    return ListScheduledQueriesCommand;
}($Command));
export { ListScheduledQueriesCommand };
