import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PrepareQueryRequest, PrepareQueryResponse } from "../models/models_0";
import { deserializeAws_json1_0PrepareQueryCommand, serializeAws_json1_0PrepareQueryCommand, } from "../protocols/Aws_json1_0";
var PrepareQueryCommand = (function (_super) {
    __extends(PrepareQueryCommand, _super);
    function PrepareQueryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PrepareQueryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamQueryClient";
        var commandName = "PrepareQueryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PrepareQueryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: PrepareQueryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PrepareQueryCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0PrepareQueryCommand(input, context);
    };
    PrepareQueryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0PrepareQueryCommand(output, context);
    };
    return PrepareQueryCommand;
}($Command));
export { PrepareQueryCommand };
