import { __extends } from "tslib";
import { getEndpointDiscoveryPlugin } from "@aws-sdk/middleware-endpoint-discovery";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpdateScheduledQueryRequest } from "../models/models_0";
import { deserializeAws_json1_0UpdateScheduledQueryCommand, serializeAws_json1_0UpdateScheduledQueryCommand, } from "../protocols/Aws_json1_0";
var UpdateScheduledQueryCommand = (function (_super) {
    __extends(UpdateScheduledQueryCommand, _super);
    function UpdateScheduledQueryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpdateScheduledQueryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointDiscoveryPlugin(configuration, { clientStack: clientStack, options: options, isDiscoveredEndpointRequired: true }));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "TimestreamQueryClient";
        var commandName = "UpdateScheduledQueryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpdateScheduledQueryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpdateScheduledQueryCommand.prototype.serialize = function (input, context) {
        return serializeAws_json1_0UpdateScheduledQueryCommand(input, context);
    };
    UpdateScheduledQueryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_json1_0UpdateScheduledQueryCommand(output, context);
    };
    return UpdateScheduledQueryCommand;
}($Command));
export { UpdateScheduledQueryCommand };
