import { __assign, __extends } from "tslib";
import { SENSITIVE_STRING } from "@aws-sdk/smithy-client";
import { TimestreamQueryServiceException as __BaseException } from "./TimestreamQueryServiceException";
var AccessDeniedException = (function (_super) {
    __extends(AccessDeniedException, _super);
    function AccessDeniedException(opts) {
        var _this = _super.call(this, __assign({ name: "AccessDeniedException", $fault: "client" }, opts)) || this;
        _this.name = "AccessDeniedException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, AccessDeniedException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return AccessDeniedException;
}(__BaseException));
export { AccessDeniedException };
export var CancelQueryRequest;
(function (CancelQueryRequest) {
    CancelQueryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CancelQueryRequest || (CancelQueryRequest = {}));
export var CancelQueryResponse;
(function (CancelQueryResponse) {
    CancelQueryResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CancelQueryResponse || (CancelQueryResponse = {}));
var InternalServerException = (function (_super) {
    __extends(InternalServerException, _super);
    function InternalServerException(opts) {
        var _this = _super.call(this, __assign({ name: "InternalServerException", $fault: "server" }, opts)) || this;
        _this.name = "InternalServerException";
        _this.$fault = "server";
        Object.setPrototypeOf(_this, InternalServerException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InternalServerException;
}(__BaseException));
export { InternalServerException };
var InvalidEndpointException = (function (_super) {
    __extends(InvalidEndpointException, _super);
    function InvalidEndpointException(opts) {
        var _this = _super.call(this, __assign({ name: "InvalidEndpointException", $fault: "client" }, opts)) || this;
        _this.name = "InvalidEndpointException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, InvalidEndpointException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return InvalidEndpointException;
}(__BaseException));
export { InvalidEndpointException };
var ThrottlingException = (function (_super) {
    __extends(ThrottlingException, _super);
    function ThrottlingException(opts) {
        var _this = _super.call(this, __assign({ name: "ThrottlingException", $fault: "client" }, opts)) || this;
        _this.name = "ThrottlingException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ThrottlingException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ThrottlingException;
}(__BaseException));
export { ThrottlingException };
var ValidationException = (function (_super) {
    __extends(ValidationException, _super);
    function ValidationException(opts) {
        var _this = _super.call(this, __assign({ name: "ValidationException", $fault: "client" }, opts)) || this;
        _this.name = "ValidationException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ValidationException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ValidationException;
}(__BaseException));
export { ValidationException };
export var ScalarType;
(function (ScalarType) {
    ScalarType["BIGINT"] = "BIGINT";
    ScalarType["BOOLEAN"] = "BOOLEAN";
    ScalarType["DATE"] = "DATE";
    ScalarType["DOUBLE"] = "DOUBLE";
    ScalarType["INTEGER"] = "INTEGER";
    ScalarType["INTERVAL_DAY_TO_SECOND"] = "INTERVAL_DAY_TO_SECOND";
    ScalarType["INTERVAL_YEAR_TO_MONTH"] = "INTERVAL_YEAR_TO_MONTH";
    ScalarType["TIME"] = "TIME";
    ScalarType["TIMESTAMP"] = "TIMESTAMP";
    ScalarType["UNKNOWN"] = "UNKNOWN";
    ScalarType["VARCHAR"] = "VARCHAR";
})(ScalarType || (ScalarType = {}));
var ConflictException = (function (_super) {
    __extends(ConflictException, _super);
    function ConflictException(opts) {
        var _this = _super.call(this, __assign({ name: "ConflictException", $fault: "client" }, opts)) || this;
        _this.name = "ConflictException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ConflictException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ConflictException;
}(__BaseException));
export { ConflictException };
export var S3EncryptionOption;
(function (S3EncryptionOption) {
    S3EncryptionOption["SSE_KMS"] = "SSE_KMS";
    S3EncryptionOption["SSE_S3"] = "SSE_S3";
})(S3EncryptionOption || (S3EncryptionOption = {}));
export var S3Configuration;
(function (S3Configuration) {
    S3Configuration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3Configuration || (S3Configuration = {}));
export var ErrorReportConfiguration;
(function (ErrorReportConfiguration) {
    ErrorReportConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ErrorReportConfiguration || (ErrorReportConfiguration = {}));
export var SnsConfiguration;
(function (SnsConfiguration) {
    SnsConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SnsConfiguration || (SnsConfiguration = {}));
export var NotificationConfiguration;
(function (NotificationConfiguration) {
    NotificationConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(NotificationConfiguration || (NotificationConfiguration = {}));
export var ScheduleConfiguration;
(function (ScheduleConfiguration) {
    ScheduleConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ScheduleConfiguration || (ScheduleConfiguration = {}));
export var Tag;
(function (Tag) {
    Tag.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Tag || (Tag = {}));
export var DimensionValueType;
(function (DimensionValueType) {
    DimensionValueType["VARCHAR"] = "VARCHAR";
})(DimensionValueType || (DimensionValueType = {}));
export var DimensionMapping;
(function (DimensionMapping) {
    DimensionMapping.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DimensionMapping || (DimensionMapping = {}));
export var MeasureValueType;
(function (MeasureValueType) {
    MeasureValueType["BIGINT"] = "BIGINT";
    MeasureValueType["BOOLEAN"] = "BOOLEAN";
    MeasureValueType["DOUBLE"] = "DOUBLE";
    MeasureValueType["MULTI"] = "MULTI";
    MeasureValueType["VARCHAR"] = "VARCHAR";
})(MeasureValueType || (MeasureValueType = {}));
export var ScalarMeasureValueType;
(function (ScalarMeasureValueType) {
    ScalarMeasureValueType["BIGINT"] = "BIGINT";
    ScalarMeasureValueType["BOOLEAN"] = "BOOLEAN";
    ScalarMeasureValueType["DOUBLE"] = "DOUBLE";
    ScalarMeasureValueType["TIMESTAMP"] = "TIMESTAMP";
    ScalarMeasureValueType["VARCHAR"] = "VARCHAR";
})(ScalarMeasureValueType || (ScalarMeasureValueType = {}));
export var MultiMeasureAttributeMapping;
(function (MultiMeasureAttributeMapping) {
    MultiMeasureAttributeMapping.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(MultiMeasureAttributeMapping || (MultiMeasureAttributeMapping = {}));
export var MixedMeasureMapping;
(function (MixedMeasureMapping) {
    MixedMeasureMapping.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(MixedMeasureMapping || (MixedMeasureMapping = {}));
export var MultiMeasureMappings;
(function (MultiMeasureMappings) {
    MultiMeasureMappings.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(MultiMeasureMappings || (MultiMeasureMappings = {}));
export var TimestreamConfiguration;
(function (TimestreamConfiguration) {
    TimestreamConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TimestreamConfiguration || (TimestreamConfiguration = {}));
export var TargetConfiguration;
(function (TargetConfiguration) {
    TargetConfiguration.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TargetConfiguration || (TargetConfiguration = {}));
export var CreateScheduledQueryRequest;
(function (CreateScheduledQueryRequest) {
    CreateScheduledQueryRequest.filterSensitiveLog = function (obj) { return (__assign(__assign(__assign({}, obj), (obj.QueryString && { QueryString: SENSITIVE_STRING })), (obj.ClientToken && { ClientToken: SENSITIVE_STRING }))); };
})(CreateScheduledQueryRequest || (CreateScheduledQueryRequest = {}));
export var CreateScheduledQueryResponse;
(function (CreateScheduledQueryResponse) {
    CreateScheduledQueryResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(CreateScheduledQueryResponse || (CreateScheduledQueryResponse = {}));
var ServiceQuotaExceededException = (function (_super) {
    __extends(ServiceQuotaExceededException, _super);
    function ServiceQuotaExceededException(opts) {
        var _this = _super.call(this, __assign({ name: "ServiceQuotaExceededException", $fault: "client" }, opts)) || this;
        _this.name = "ServiceQuotaExceededException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ServiceQuotaExceededException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return ServiceQuotaExceededException;
}(__BaseException));
export { ServiceQuotaExceededException };
export var DeleteScheduledQueryRequest;
(function (DeleteScheduledQueryRequest) {
    DeleteScheduledQueryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DeleteScheduledQueryRequest || (DeleteScheduledQueryRequest = {}));
var ResourceNotFoundException = (function (_super) {
    __extends(ResourceNotFoundException, _super);
    function ResourceNotFoundException(opts) {
        var _this = _super.call(this, __assign({ name: "ResourceNotFoundException", $fault: "client" }, opts)) || this;
        _this.name = "ResourceNotFoundException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, ResourceNotFoundException.prototype);
        _this.Message = opts.Message;
        _this.ScheduledQueryArn = opts.ScheduledQueryArn;
        return _this;
    }
    return ResourceNotFoundException;
}(__BaseException));
export { ResourceNotFoundException };
export var DescribeEndpointsRequest;
(function (DescribeEndpointsRequest) {
    DescribeEndpointsRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEndpointsRequest || (DescribeEndpointsRequest = {}));
export var Endpoint;
(function (Endpoint) {
    Endpoint.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Endpoint || (Endpoint = {}));
export var DescribeEndpointsResponse;
(function (DescribeEndpointsResponse) {
    DescribeEndpointsResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeEndpointsResponse || (DescribeEndpointsResponse = {}));
export var DescribeScheduledQueryRequest;
(function (DescribeScheduledQueryRequest) {
    DescribeScheduledQueryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(DescribeScheduledQueryRequest || (DescribeScheduledQueryRequest = {}));
export var S3ReportLocation;
(function (S3ReportLocation) {
    S3ReportLocation.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(S3ReportLocation || (S3ReportLocation = {}));
export var ErrorReportLocation;
(function (ErrorReportLocation) {
    ErrorReportLocation.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ErrorReportLocation || (ErrorReportLocation = {}));
export var ExecutionStats;
(function (ExecutionStats) {
    ExecutionStats.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ExecutionStats || (ExecutionStats = {}));
export var ScheduledQueryRunStatus;
(function (ScheduledQueryRunStatus) {
    ScheduledQueryRunStatus["AUTO_TRIGGER_FAILURE"] = "AUTO_TRIGGER_FAILURE";
    ScheduledQueryRunStatus["AUTO_TRIGGER_SUCCESS"] = "AUTO_TRIGGER_SUCCESS";
    ScheduledQueryRunStatus["MANUAL_TRIGGER_FAILURE"] = "MANUAL_TRIGGER_FAILURE";
    ScheduledQueryRunStatus["MANUAL_TRIGGER_SUCCESS"] = "MANUAL_TRIGGER_SUCCESS";
})(ScheduledQueryRunStatus || (ScheduledQueryRunStatus = {}));
export var ScheduledQueryRunSummary;
(function (ScheduledQueryRunSummary) {
    ScheduledQueryRunSummary.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ScheduledQueryRunSummary || (ScheduledQueryRunSummary = {}));
export var ScheduledQueryState;
(function (ScheduledQueryState) {
    ScheduledQueryState["DISABLED"] = "DISABLED";
    ScheduledQueryState["ENABLED"] = "ENABLED";
})(ScheduledQueryState || (ScheduledQueryState = {}));
export var ScheduledQueryDescription;
(function (ScheduledQueryDescription) {
    ScheduledQueryDescription.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.QueryString && { QueryString: SENSITIVE_STRING }))); };
})(ScheduledQueryDescription || (ScheduledQueryDescription = {}));
export var DescribeScheduledQueryResponse;
(function (DescribeScheduledQueryResponse) {
    DescribeScheduledQueryResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.ScheduledQuery && { ScheduledQuery: ScheduledQueryDescription.filterSensitiveLog(obj.ScheduledQuery) }))); };
})(DescribeScheduledQueryResponse || (DescribeScheduledQueryResponse = {}));
export var ExecuteScheduledQueryRequest;
(function (ExecuteScheduledQueryRequest) {
    ExecuteScheduledQueryRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.ClientToken && { ClientToken: SENSITIVE_STRING }))); };
})(ExecuteScheduledQueryRequest || (ExecuteScheduledQueryRequest = {}));
export var ListScheduledQueriesRequest;
(function (ListScheduledQueriesRequest) {
    ListScheduledQueriesRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListScheduledQueriesRequest || (ListScheduledQueriesRequest = {}));
export var TimestreamDestination;
(function (TimestreamDestination) {
    TimestreamDestination.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TimestreamDestination || (TimestreamDestination = {}));
export var TargetDestination;
(function (TargetDestination) {
    TargetDestination.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TargetDestination || (TargetDestination = {}));
export var ScheduledQuery;
(function (ScheduledQuery) {
    ScheduledQuery.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ScheduledQuery || (ScheduledQuery = {}));
export var ListScheduledQueriesResponse;
(function (ListScheduledQueriesResponse) {
    ListScheduledQueriesResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListScheduledQueriesResponse || (ListScheduledQueriesResponse = {}));
export var ListTagsForResourceRequest;
(function (ListTagsForResourceRequest) {
    ListTagsForResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceRequest || (ListTagsForResourceRequest = {}));
export var ListTagsForResourceResponse;
(function (ListTagsForResourceResponse) {
    ListTagsForResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ListTagsForResourceResponse || (ListTagsForResourceResponse = {}));
export var PrepareQueryRequest;
(function (PrepareQueryRequest) {
    PrepareQueryRequest.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.QueryString && { QueryString: SENSITIVE_STRING }))); };
})(PrepareQueryRequest || (PrepareQueryRequest = {}));
var QueryExecutionException = (function (_super) {
    __extends(QueryExecutionException, _super);
    function QueryExecutionException(opts) {
        var _this = _super.call(this, __assign({ name: "QueryExecutionException", $fault: "client" }, opts)) || this;
        _this.name = "QueryExecutionException";
        _this.$fault = "client";
        Object.setPrototypeOf(_this, QueryExecutionException.prototype);
        _this.Message = opts.Message;
        return _this;
    }
    return QueryExecutionException;
}(__BaseException));
export { QueryExecutionException };
export var QueryRequest;
(function (QueryRequest) {
    QueryRequest.filterSensitiveLog = function (obj) { return (__assign(__assign(__assign({}, obj), (obj.QueryString && { QueryString: SENSITIVE_STRING })), (obj.ClientToken && { ClientToken: SENSITIVE_STRING }))); };
})(QueryRequest || (QueryRequest = {}));
export var QueryStatus;
(function (QueryStatus) {
    QueryStatus.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(QueryStatus || (QueryStatus = {}));
export var TagResourceRequest;
(function (TagResourceRequest) {
    TagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceRequest || (TagResourceRequest = {}));
export var TagResourceResponse;
(function (TagResourceResponse) {
    TagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TagResourceResponse || (TagResourceResponse = {}));
export var UntagResourceRequest;
(function (UntagResourceRequest) {
    UntagResourceRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceRequest || (UntagResourceRequest = {}));
export var UntagResourceResponse;
(function (UntagResourceResponse) {
    UntagResourceResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UntagResourceResponse || (UntagResourceResponse = {}));
export var UpdateScheduledQueryRequest;
(function (UpdateScheduledQueryRequest) {
    UpdateScheduledQueryRequest.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(UpdateScheduledQueryRequest || (UpdateScheduledQueryRequest = {}));
export var ColumnInfo;
(function (ColumnInfo) {
    ColumnInfo.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ColumnInfo || (ColumnInfo = {}));
export var Type;
(function (Type) {
    Type.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Type || (Type = {}));
export var Datum;
(function (Datum) {
    Datum.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Datum || (Datum = {}));
export var ParameterMapping;
(function (ParameterMapping) {
    ParameterMapping.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(ParameterMapping || (ParameterMapping = {}));
export var SelectColumn;
(function (SelectColumn) {
    SelectColumn.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(SelectColumn || (SelectColumn = {}));
export var TimeSeriesDataPoint;
(function (TimeSeriesDataPoint) {
    TimeSeriesDataPoint.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(TimeSeriesDataPoint || (TimeSeriesDataPoint = {}));
export var Row;
(function (Row) {
    Row.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(Row || (Row = {}));
export var QueryResponse;
(function (QueryResponse) {
    QueryResponse.filterSensitiveLog = function (obj) { return (__assign({}, obj)); };
})(QueryResponse || (QueryResponse = {}));
export var PrepareQueryResponse;
(function (PrepareQueryResponse) {
    PrepareQueryResponse.filterSensitiveLog = function (obj) { return (__assign(__assign({}, obj), (obj.QueryString && { QueryString: SENSITIVE_STRING }))); };
})(PrepareQueryResponse || (PrepareQueryResponse = {}));
