import { __assign, __awaiter, __generator } from "tslib";
import { HttpRequest as __HttpRequest } from "@aws-sdk/protocol-http";
import { decorateServiceException as __decorateServiceException, expectBoolean as __expectBoolean, expectLong as __expectLong, expectNonNull as __expectNonNull, expectNumber as __expectNumber, expectString as __expectString, limitedParseDouble as __limitedParseDouble, parseEpochTimestamp as __parseEpochTimestamp, } from "@aws-sdk/smithy-client";
import { v4 as generateIdempotencyToken } from "uuid";
import { AccessDeniedException, ConflictException, InternalServerException, InvalidEndpointException, QueryExecutionException, ResourceNotFoundException, ServiceQuotaExceededException, ThrottlingException, ValidationException, } from "../models/models_0";
import { TimestreamQueryServiceException as __BaseException } from "../models/TimestreamQueryServiceException";
export var serializeAws_json1_0CancelQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.CancelQuery",
        };
        body = JSON.stringify(serializeAws_json1_0CancelQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0CreateScheduledQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.CreateScheduledQuery",
        };
        body = JSON.stringify(serializeAws_json1_0CreateScheduledQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0DeleteScheduledQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.DeleteScheduledQuery",
        };
        body = JSON.stringify(serializeAws_json1_0DeleteScheduledQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0DescribeEndpointsCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.DescribeEndpoints",
        };
        body = JSON.stringify(serializeAws_json1_0DescribeEndpointsRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0DescribeScheduledQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.DescribeScheduledQuery",
        };
        body = JSON.stringify(serializeAws_json1_0DescribeScheduledQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0ExecuteScheduledQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.ExecuteScheduledQuery",
        };
        body = JSON.stringify(serializeAws_json1_0ExecuteScheduledQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0ListScheduledQueriesCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.ListScheduledQueries",
        };
        body = JSON.stringify(serializeAws_json1_0ListScheduledQueriesRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0ListTagsForResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.ListTagsForResource",
        };
        body = JSON.stringify(serializeAws_json1_0ListTagsForResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0PrepareQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.PrepareQuery",
        };
        body = JSON.stringify(serializeAws_json1_0PrepareQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0QueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.Query",
        };
        body = JSON.stringify(serializeAws_json1_0QueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0TagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.TagResource",
        };
        body = JSON.stringify(serializeAws_json1_0TagResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0UntagResourceCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.UntagResource",
        };
        body = JSON.stringify(serializeAws_json1_0UntagResourceRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var serializeAws_json1_0UpdateScheduledQueryCommand = function (input, context) { return __awaiter(void 0, void 0, void 0, function () {
    var headers, body;
    return __generator(this, function (_a) {
        headers = {
            "content-type": "application/x-amz-json-1.0",
            "x-amz-target": "Timestream_20181101.UpdateScheduledQuery",
        };
        body = JSON.stringify(serializeAws_json1_0UpdateScheduledQueryRequest(input, context));
        return [2, buildHttpRpcRequest(context, headers, "/", undefined, body)];
    });
}); };
export var deserializeAws_json1_0CancelQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0CancelQueryCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0CancelQueryResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0CancelQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0CreateScheduledQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0CreateScheduledQueryCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0CreateScheduledQueryResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0CreateScheduledQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 6];
                    case "InvalidEndpointException": return [3, 8];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 8];
                    case "ServiceQuotaExceededException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ServiceQuotaExceededException": return [3, 10];
                    case "ThrottlingException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 12];
                    case "ValidationException": return [3, 14];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 14];
                }
                return [3, 16];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ServiceQuotaExceededExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 15: throw _d.sent();
            case 16:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0DeleteScheduledQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0DeleteScheduledQueryCommandError(output, context)];
                }
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                response = {
                    $metadata: deserializeMetadata(output),
                };
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0DeleteScheduledQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0DescribeEndpointsCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0DescribeEndpointsCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0DescribeEndpointsResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0DescribeEndpointsCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InternalServerException": return [3, 2];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 2];
                    case "ThrottlingException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 4];
                    case "ValidationException": return [3, 6];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 6];
                }
                return [3, 8];
            case 2: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0DescribeScheduledQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0DescribeScheduledQueryCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0DescribeScheduledQueryResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0DescribeScheduledQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0ExecuteScheduledQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0ExecuteScheduledQueryCommandError(output, context)];
                }
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                response = {
                    $metadata: deserializeMetadata(output),
                };
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0ExecuteScheduledQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0ListScheduledQueriesCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0ListScheduledQueriesCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0ListScheduledQueriesResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0ListScheduledQueriesCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0ListTagsForResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0ListTagsForResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0ListTagsForResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0ListTagsForResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InvalidEndpointException": return [3, 2];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0PrepareQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0PrepareQueryCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0PrepareQueryResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0PrepareQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0QueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0QueryCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0QueryResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0QueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "ConflictException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ConflictException": return [3, 4];
                    case "InternalServerException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 6];
                    case "InvalidEndpointException": return [3, 8];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 8];
                    case "QueryExecutionException": return [3, 10];
                    case "com.amazonaws.timestreamquery#QueryExecutionException": return [3, 10];
                    case "ThrottlingException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 12];
                    case "ValidationException": return [3, 14];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 14];
                }
                return [3, 16];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ConflictExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0QueryExecutionExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 15: throw _d.sent();
            case 16:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0TagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0TagResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0TagResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0TagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InvalidEndpointException": return [3, 2];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 4];
                    case "ServiceQuotaExceededException": return [3, 6];
                    case "com.amazonaws.timestreamquery#ServiceQuotaExceededException": return [3, 6];
                    case "ThrottlingException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 8];
                    case "ValidationException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 10];
                }
                return [3, 12];
            case 2: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0ServiceQuotaExceededExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0UntagResourceCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var data, contents, response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0UntagResourceCommandError(output, context)];
                }
                return [4, parseBody(output.body, context)];
            case 1:
                data = _a.sent();
                contents = {};
                contents = deserializeAws_json1_0UntagResourceResponse(data, context);
                response = __assign({ $metadata: deserializeMetadata(output) }, contents);
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0UntagResourceCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "InvalidEndpointException": return [3, 2];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 2];
                    case "ResourceNotFoundException": return [3, 4];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 4];
                    case "ThrottlingException": return [3, 6];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 6];
                    case "ValidationException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 8];
                }
                return [3, 10];
            case 2: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
export var deserializeAws_json1_0UpdateScheduledQueryCommand = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var response;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (output.statusCode >= 300) {
                    return [2, deserializeAws_json1_0UpdateScheduledQueryCommandError(output, context)];
                }
                return [4, collectBody(output.body, context)];
            case 1:
                _a.sent();
                response = {
                    $metadata: deserializeMetadata(output),
                };
                return [2, Promise.resolve(response)];
        }
    });
}); };
var deserializeAws_json1_0UpdateScheduledQueryCommandError = function (output, context) { return __awaiter(void 0, void 0, void 0, function () {
    var parsedOutput, _a, response, errorCode, _b, parsedBody;
    var _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = [__assign({}, output)];
                _c = {};
                return [4, parseBody(output.body, context)];
            case 1:
                parsedOutput = __assign.apply(void 0, _a.concat([(_c.body = _d.sent(), _c)]));
                errorCode = "UnknownError";
                errorCode = loadRestJsonErrorCode(output, parsedOutput.body);
                _b = errorCode;
                switch (_b) {
                    case "AccessDeniedException": return [3, 2];
                    case "com.amazonaws.timestreamquery#AccessDeniedException": return [3, 2];
                    case "InternalServerException": return [3, 4];
                    case "com.amazonaws.timestreamquery#InternalServerException": return [3, 4];
                    case "InvalidEndpointException": return [3, 6];
                    case "com.amazonaws.timestreamquery#InvalidEndpointException": return [3, 6];
                    case "ResourceNotFoundException": return [3, 8];
                    case "com.amazonaws.timestreamquery#ResourceNotFoundException": return [3, 8];
                    case "ThrottlingException": return [3, 10];
                    case "com.amazonaws.timestreamquery#ThrottlingException": return [3, 10];
                    case "ValidationException": return [3, 12];
                    case "com.amazonaws.timestreamquery#ValidationException": return [3, 12];
                }
                return [3, 14];
            case 2: return [4, deserializeAws_json1_0AccessDeniedExceptionResponse(parsedOutput, context)];
            case 3: throw _d.sent();
            case 4: return [4, deserializeAws_json1_0InternalServerExceptionResponse(parsedOutput, context)];
            case 5: throw _d.sent();
            case 6: return [4, deserializeAws_json1_0InvalidEndpointExceptionResponse(parsedOutput, context)];
            case 7: throw _d.sent();
            case 8: return [4, deserializeAws_json1_0ResourceNotFoundExceptionResponse(parsedOutput, context)];
            case 9: throw _d.sent();
            case 10: return [4, deserializeAws_json1_0ThrottlingExceptionResponse(parsedOutput, context)];
            case 11: throw _d.sent();
            case 12: return [4, deserializeAws_json1_0ValidationExceptionResponse(parsedOutput, context)];
            case 13: throw _d.sent();
            case 14:
                parsedBody = parsedOutput.body;
                response = new __BaseException({
                    name: parsedBody.code || parsedBody.Code || errorCode,
                    $fault: "client",
                    $metadata: deserializeMetadata(output),
                });
                throw __decorateServiceException(response, parsedBody);
        }
    });
}); };
var deserializeAws_json1_0AccessDeniedExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0AccessDeniedException(body, context);
        exception = new AccessDeniedException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0ConflictExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0ConflictException(body, context);
        exception = new ConflictException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0InternalServerExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0InternalServerException(body, context);
        exception = new InternalServerException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0InvalidEndpointExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0InvalidEndpointException(body, context);
        exception = new InvalidEndpointException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0QueryExecutionExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0QueryExecutionException(body, context);
        exception = new QueryExecutionException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0ResourceNotFoundExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0ResourceNotFoundException(body, context);
        exception = new ResourceNotFoundException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0ServiceQuotaExceededExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0ServiceQuotaExceededException(body, context);
        exception = new ServiceQuotaExceededException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0ThrottlingExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0ThrottlingException(body, context);
        exception = new ThrottlingException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var deserializeAws_json1_0ValidationExceptionResponse = function (parsedOutput, context) { return __awaiter(void 0, void 0, void 0, function () {
    var body, deserialized, exception;
    return __generator(this, function (_a) {
        body = parsedOutput.body;
        deserialized = deserializeAws_json1_0ValidationException(body, context);
        exception = new ValidationException(__assign({ $metadata: deserializeMetadata(parsedOutput) }, deserialized));
        return [2, __decorateServiceException(exception, body)];
    });
}); };
var serializeAws_json1_0CancelQueryRequest = function (input, context) {
    return __assign({}, (input.QueryId !== undefined && input.QueryId !== null && { QueryId: input.QueryId }));
};
var serializeAws_json1_0CreateScheduledQueryRequest = function (input, context) {
    var _a;
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign(__assign({ ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : generateIdempotencyToken() }, (input.ErrorReportConfiguration !== undefined &&
        input.ErrorReportConfiguration !== null && {
        ErrorReportConfiguration: serializeAws_json1_0ErrorReportConfiguration(input.ErrorReportConfiguration, context),
    })), (input.KmsKeyId !== undefined && input.KmsKeyId !== null && { KmsKeyId: input.KmsKeyId })), (input.Name !== undefined && input.Name !== null && { Name: input.Name })), (input.NotificationConfiguration !== undefined &&
        input.NotificationConfiguration !== null && {
        NotificationConfiguration: serializeAws_json1_0NotificationConfiguration(input.NotificationConfiguration, context),
    })), (input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString })), (input.ScheduleConfiguration !== undefined &&
        input.ScheduleConfiguration !== null && {
        ScheduleConfiguration: serializeAws_json1_0ScheduleConfiguration(input.ScheduleConfiguration, context),
    })), (input.ScheduledQueryExecutionRoleArn !== undefined &&
        input.ScheduledQueryExecutionRoleArn !== null && {
        ScheduledQueryExecutionRoleArn: input.ScheduledQueryExecutionRoleArn,
    })), (input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_0TagList(input.Tags, context) })), (input.TargetConfiguration !== undefined &&
        input.TargetConfiguration !== null && {
        TargetConfiguration: serializeAws_json1_0TargetConfiguration(input.TargetConfiguration, context),
    }));
};
var serializeAws_json1_0DeleteScheduledQueryRequest = function (input, context) {
    return __assign({}, (input.ScheduledQueryArn !== undefined &&
        input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }));
};
var serializeAws_json1_0DescribeEndpointsRequest = function (input, context) {
    return {};
};
var serializeAws_json1_0DescribeScheduledQueryRequest = function (input, context) {
    return __assign({}, (input.ScheduledQueryArn !== undefined &&
        input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }));
};
var serializeAws_json1_0DimensionMapping = function (input, context) {
    return __assign(__assign({}, (input.DimensionValueType !== undefined &&
        input.DimensionValueType !== null && { DimensionValueType: input.DimensionValueType })), (input.Name !== undefined && input.Name !== null && { Name: input.Name }));
};
var serializeAws_json1_0DimensionMappingList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0DimensionMapping(entry, context);
    });
};
var serializeAws_json1_0ErrorReportConfiguration = function (input, context) {
    return __assign({}, (input.S3Configuration !== undefined &&
        input.S3Configuration !== null && {
        S3Configuration: serializeAws_json1_0S3Configuration(input.S3Configuration, context),
    }));
};
var serializeAws_json1_0ExecuteScheduledQueryRequest = function (input, context) {
    var _a;
    return __assign(__assign({ ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : generateIdempotencyToken() }, (input.InvocationTime !== undefined &&
        input.InvocationTime !== null && { InvocationTime: Math.round(input.InvocationTime.getTime() / 1000) })), (input.ScheduledQueryArn !== undefined &&
        input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn }));
};
var serializeAws_json1_0ListScheduledQueriesRequest = function (input, context) {
    return __assign(__assign({}, (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken }));
};
var serializeAws_json1_0ListTagsForResourceRequest = function (input, context) {
    return __assign(__assign(__assign({}, (input.MaxResults !== undefined && input.MaxResults !== null && { MaxResults: input.MaxResults })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken })), (input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN }));
};
var serializeAws_json1_0MixedMeasureMapping = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign({}, (input.MeasureName !== undefined && input.MeasureName !== null && { MeasureName: input.MeasureName })), (input.MeasureValueType !== undefined &&
        input.MeasureValueType !== null && { MeasureValueType: input.MeasureValueType })), (input.MultiMeasureAttributeMappings !== undefined &&
        input.MultiMeasureAttributeMappings !== null && {
        MultiMeasureAttributeMappings: serializeAws_json1_0MultiMeasureAttributeMappingList(input.MultiMeasureAttributeMappings, context),
    })), (input.SourceColumn !== undefined && input.SourceColumn !== null && { SourceColumn: input.SourceColumn })), (input.TargetMeasureName !== undefined &&
        input.TargetMeasureName !== null && { TargetMeasureName: input.TargetMeasureName }));
};
var serializeAws_json1_0MixedMeasureMappingList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0MixedMeasureMapping(entry, context);
    });
};
var serializeAws_json1_0MultiMeasureAttributeMapping = function (input, context) {
    return __assign(__assign(__assign({}, (input.MeasureValueType !== undefined &&
        input.MeasureValueType !== null && { MeasureValueType: input.MeasureValueType })), (input.SourceColumn !== undefined && input.SourceColumn !== null && { SourceColumn: input.SourceColumn })), (input.TargetMultiMeasureAttributeName !== undefined &&
        input.TargetMultiMeasureAttributeName !== null && {
        TargetMultiMeasureAttributeName: input.TargetMultiMeasureAttributeName,
    }));
};
var serializeAws_json1_0MultiMeasureAttributeMappingList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0MultiMeasureAttributeMapping(entry, context);
    });
};
var serializeAws_json1_0MultiMeasureMappings = function (input, context) {
    return __assign(__assign({}, (input.MultiMeasureAttributeMappings !== undefined &&
        input.MultiMeasureAttributeMappings !== null && {
        MultiMeasureAttributeMappings: serializeAws_json1_0MultiMeasureAttributeMappingList(input.MultiMeasureAttributeMappings, context),
    })), (input.TargetMultiMeasureName !== undefined &&
        input.TargetMultiMeasureName !== null && { TargetMultiMeasureName: input.TargetMultiMeasureName }));
};
var serializeAws_json1_0NotificationConfiguration = function (input, context) {
    return __assign({}, (input.SnsConfiguration !== undefined &&
        input.SnsConfiguration !== null && {
        SnsConfiguration: serializeAws_json1_0SnsConfiguration(input.SnsConfiguration, context),
    }));
};
var serializeAws_json1_0PrepareQueryRequest = function (input, context) {
    return __assign(__assign({}, (input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString })), (input.ValidateOnly !== undefined && input.ValidateOnly !== null && { ValidateOnly: input.ValidateOnly }));
};
var serializeAws_json1_0QueryRequest = function (input, context) {
    var _a;
    return __assign(__assign(__assign({ ClientToken: (_a = input.ClientToken) !== null && _a !== void 0 ? _a : generateIdempotencyToken() }, (input.MaxRows !== undefined && input.MaxRows !== null && { MaxRows: input.MaxRows })), (input.NextToken !== undefined && input.NextToken !== null && { NextToken: input.NextToken })), (input.QueryString !== undefined && input.QueryString !== null && { QueryString: input.QueryString }));
};
var serializeAws_json1_0S3Configuration = function (input, context) {
    return __assign(__assign(__assign({}, (input.BucketName !== undefined && input.BucketName !== null && { BucketName: input.BucketName })), (input.EncryptionOption !== undefined &&
        input.EncryptionOption !== null && { EncryptionOption: input.EncryptionOption })), (input.ObjectKeyPrefix !== undefined &&
        input.ObjectKeyPrefix !== null && { ObjectKeyPrefix: input.ObjectKeyPrefix }));
};
var serializeAws_json1_0ScheduleConfiguration = function (input, context) {
    return __assign({}, (input.ScheduleExpression !== undefined &&
        input.ScheduleExpression !== null && { ScheduleExpression: input.ScheduleExpression }));
};
var serializeAws_json1_0SnsConfiguration = function (input, context) {
    return __assign({}, (input.TopicArn !== undefined && input.TopicArn !== null && { TopicArn: input.TopicArn }));
};
var serializeAws_json1_0Tag = function (input, context) {
    return __assign(__assign({}, (input.Key !== undefined && input.Key !== null && { Key: input.Key })), (input.Value !== undefined && input.Value !== null && { Value: input.Value }));
};
var serializeAws_json1_0TagKeyList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return entry;
    });
};
var serializeAws_json1_0TagList = function (input, context) {
    return input
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return serializeAws_json1_0Tag(entry, context);
    });
};
var serializeAws_json1_0TagResourceRequest = function (input, context) {
    return __assign(__assign({}, (input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN })), (input.Tags !== undefined && input.Tags !== null && { Tags: serializeAws_json1_0TagList(input.Tags, context) }));
};
var serializeAws_json1_0TargetConfiguration = function (input, context) {
    return __assign({}, (input.TimestreamConfiguration !== undefined &&
        input.TimestreamConfiguration !== null && {
        TimestreamConfiguration: serializeAws_json1_0TimestreamConfiguration(input.TimestreamConfiguration, context),
    }));
};
var serializeAws_json1_0TimestreamConfiguration = function (input, context) {
    return __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, (input.DatabaseName !== undefined && input.DatabaseName !== null && { DatabaseName: input.DatabaseName })), (input.DimensionMappings !== undefined &&
        input.DimensionMappings !== null && {
        DimensionMappings: serializeAws_json1_0DimensionMappingList(input.DimensionMappings, context),
    })), (input.MeasureNameColumn !== undefined &&
        input.MeasureNameColumn !== null && { MeasureNameColumn: input.MeasureNameColumn })), (input.MixedMeasureMappings !== undefined &&
        input.MixedMeasureMappings !== null && {
        MixedMeasureMappings: serializeAws_json1_0MixedMeasureMappingList(input.MixedMeasureMappings, context),
    })), (input.MultiMeasureMappings !== undefined &&
        input.MultiMeasureMappings !== null && {
        MultiMeasureMappings: serializeAws_json1_0MultiMeasureMappings(input.MultiMeasureMappings, context),
    })), (input.TableName !== undefined && input.TableName !== null && { TableName: input.TableName })), (input.TimeColumn !== undefined && input.TimeColumn !== null && { TimeColumn: input.TimeColumn }));
};
var serializeAws_json1_0UntagResourceRequest = function (input, context) {
    return __assign(__assign({}, (input.ResourceARN !== undefined && input.ResourceARN !== null && { ResourceARN: input.ResourceARN })), (input.TagKeys !== undefined &&
        input.TagKeys !== null && { TagKeys: serializeAws_json1_0TagKeyList(input.TagKeys, context) }));
};
var serializeAws_json1_0UpdateScheduledQueryRequest = function (input, context) {
    return __assign(__assign({}, (input.ScheduledQueryArn !== undefined &&
        input.ScheduledQueryArn !== null && { ScheduledQueryArn: input.ScheduledQueryArn })), (input.State !== undefined && input.State !== null && { State: input.State }));
};
var deserializeAws_json1_0AccessDeniedException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0CancelQueryResponse = function (output, context) {
    return {
        CancellationMessage: __expectString(output.CancellationMessage),
    };
};
var deserializeAws_json1_0ColumnInfo = function (output, context) {
    return {
        Name: __expectString(output.Name),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
var deserializeAws_json1_0ColumnInfoList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ColumnInfo(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0ConflictException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0CreateScheduledQueryResponse = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
    };
};
var deserializeAws_json1_0Datum = function (output, context) {
    return {
        ArrayValue: output.ArrayValue !== undefined && output.ArrayValue !== null
            ? deserializeAws_json1_0DatumList(output.ArrayValue, context)
            : undefined,
        NullValue: __expectBoolean(output.NullValue),
        RowValue: output.RowValue !== undefined && output.RowValue !== null
            ? deserializeAws_json1_0Row(output.RowValue, context)
            : undefined,
        ScalarValue: __expectString(output.ScalarValue),
        TimeSeriesValue: output.TimeSeriesValue !== undefined && output.TimeSeriesValue !== null
            ? deserializeAws_json1_0TimeSeriesDataPointList(output.TimeSeriesValue, context)
            : undefined,
    };
};
var deserializeAws_json1_0DatumList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Datum(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0DescribeEndpointsResponse = function (output, context) {
    return {
        Endpoints: output.Endpoints !== undefined && output.Endpoints !== null
            ? deserializeAws_json1_0Endpoints(output.Endpoints, context)
            : undefined,
    };
};
var deserializeAws_json1_0DescribeScheduledQueryResponse = function (output, context) {
    return {
        ScheduledQuery: output.ScheduledQuery !== undefined && output.ScheduledQuery !== null
            ? deserializeAws_json1_0ScheduledQueryDescription(output.ScheduledQuery, context)
            : undefined,
    };
};
var deserializeAws_json1_0DimensionMapping = function (output, context) {
    return {
        DimensionValueType: __expectString(output.DimensionValueType),
        Name: __expectString(output.Name),
    };
};
var deserializeAws_json1_0DimensionMappingList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0DimensionMapping(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0Endpoint = function (output, context) {
    return {
        Address: __expectString(output.Address),
        CachePeriodInMinutes: __expectLong(output.CachePeriodInMinutes),
    };
};
var deserializeAws_json1_0Endpoints = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Endpoint(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0ErrorReportConfiguration = function (output, context) {
    return {
        S3Configuration: output.S3Configuration !== undefined && output.S3Configuration !== null
            ? deserializeAws_json1_0S3Configuration(output.S3Configuration, context)
            : undefined,
    };
};
var deserializeAws_json1_0ErrorReportLocation = function (output, context) {
    return {
        S3ReportLocation: output.S3ReportLocation !== undefined && output.S3ReportLocation !== null
            ? deserializeAws_json1_0S3ReportLocation(output.S3ReportLocation, context)
            : undefined,
    };
};
var deserializeAws_json1_0ExecutionStats = function (output, context) {
    return {
        BytesMetered: __expectLong(output.BytesMetered),
        DataWrites: __expectLong(output.DataWrites),
        ExecutionTimeInMillis: __expectLong(output.ExecutionTimeInMillis),
        QueryResultRows: __expectLong(output.QueryResultRows),
        RecordsIngested: __expectLong(output.RecordsIngested),
    };
};
var deserializeAws_json1_0InternalServerException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0InvalidEndpointException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0ListScheduledQueriesResponse = function (output, context) {
    return {
        NextToken: __expectString(output.NextToken),
        ScheduledQueries: output.ScheduledQueries !== undefined && output.ScheduledQueries !== null
            ? deserializeAws_json1_0ScheduledQueryList(output.ScheduledQueries, context)
            : undefined,
    };
};
var deserializeAws_json1_0ListTagsForResourceResponse = function (output, context) {
    return {
        NextToken: __expectString(output.NextToken),
        Tags: output.Tags !== undefined && output.Tags !== null
            ? deserializeAws_json1_0TagList(output.Tags, context)
            : undefined,
    };
};
var deserializeAws_json1_0MixedMeasureMapping = function (output, context) {
    return {
        MeasureName: __expectString(output.MeasureName),
        MeasureValueType: __expectString(output.MeasureValueType),
        MultiMeasureAttributeMappings: output.MultiMeasureAttributeMappings !== undefined && output.MultiMeasureAttributeMappings !== null
            ? deserializeAws_json1_0MultiMeasureAttributeMappingList(output.MultiMeasureAttributeMappings, context)
            : undefined,
        SourceColumn: __expectString(output.SourceColumn),
        TargetMeasureName: __expectString(output.TargetMeasureName),
    };
};
var deserializeAws_json1_0MixedMeasureMappingList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0MixedMeasureMapping(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0MultiMeasureAttributeMapping = function (output, context) {
    return {
        MeasureValueType: __expectString(output.MeasureValueType),
        SourceColumn: __expectString(output.SourceColumn),
        TargetMultiMeasureAttributeName: __expectString(output.TargetMultiMeasureAttributeName),
    };
};
var deserializeAws_json1_0MultiMeasureAttributeMappingList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0MultiMeasureAttributeMapping(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0MultiMeasureMappings = function (output, context) {
    return {
        MultiMeasureAttributeMappings: output.MultiMeasureAttributeMappings !== undefined && output.MultiMeasureAttributeMappings !== null
            ? deserializeAws_json1_0MultiMeasureAttributeMappingList(output.MultiMeasureAttributeMappings, context)
            : undefined,
        TargetMultiMeasureName: __expectString(output.TargetMultiMeasureName),
    };
};
var deserializeAws_json1_0NotificationConfiguration = function (output, context) {
    return {
        SnsConfiguration: output.SnsConfiguration !== undefined && output.SnsConfiguration !== null
            ? deserializeAws_json1_0SnsConfiguration(output.SnsConfiguration, context)
            : undefined,
    };
};
var deserializeAws_json1_0ParameterMapping = function (output, context) {
    return {
        Name: __expectString(output.Name),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
var deserializeAws_json1_0ParameterMappingList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ParameterMapping(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0PrepareQueryResponse = function (output, context) {
    return {
        Columns: output.Columns !== undefined && output.Columns !== null
            ? deserializeAws_json1_0SelectColumnList(output.Columns, context)
            : undefined,
        Parameters: output.Parameters !== undefined && output.Parameters !== null
            ? deserializeAws_json1_0ParameterMappingList(output.Parameters, context)
            : undefined,
        QueryString: __expectString(output.QueryString),
    };
};
var deserializeAws_json1_0QueryExecutionException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0QueryResponse = function (output, context) {
    return {
        ColumnInfo: output.ColumnInfo !== undefined && output.ColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfoList(output.ColumnInfo, context)
            : undefined,
        NextToken: __expectString(output.NextToken),
        QueryId: __expectString(output.QueryId),
        QueryStatus: output.QueryStatus !== undefined && output.QueryStatus !== null
            ? deserializeAws_json1_0QueryStatus(output.QueryStatus, context)
            : undefined,
        Rows: output.Rows !== undefined && output.Rows !== null
            ? deserializeAws_json1_0RowList(output.Rows, context)
            : undefined,
    };
};
var deserializeAws_json1_0QueryStatus = function (output, context) {
    return {
        CumulativeBytesMetered: __expectLong(output.CumulativeBytesMetered),
        CumulativeBytesScanned: __expectLong(output.CumulativeBytesScanned),
        ProgressPercentage: __limitedParseDouble(output.ProgressPercentage),
    };
};
var deserializeAws_json1_0ResourceNotFoundException = function (output, context) {
    return {
        Message: __expectString(output.Message),
        ScheduledQueryArn: __expectString(output.ScheduledQueryArn),
    };
};
var deserializeAws_json1_0Row = function (output, context) {
    return {
        Data: output.Data !== undefined && output.Data !== null
            ? deserializeAws_json1_0DatumList(output.Data, context)
            : undefined,
    };
};
var deserializeAws_json1_0RowList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Row(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0S3Configuration = function (output, context) {
    return {
        BucketName: __expectString(output.BucketName),
        EncryptionOption: __expectString(output.EncryptionOption),
        ObjectKeyPrefix: __expectString(output.ObjectKeyPrefix),
    };
};
var deserializeAws_json1_0S3ReportLocation = function (output, context) {
    return {
        BucketName: __expectString(output.BucketName),
        ObjectKey: __expectString(output.ObjectKey),
    };
};
var deserializeAws_json1_0ScheduleConfiguration = function (output, context) {
    return {
        ScheduleExpression: __expectString(output.ScheduleExpression),
    };
};
var deserializeAws_json1_0ScheduledQuery = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        ErrorReportConfiguration: output.ErrorReportConfiguration !== undefined && output.ErrorReportConfiguration !== null
            ? deserializeAws_json1_0ErrorReportConfiguration(output.ErrorReportConfiguration, context)
            : undefined,
        LastRunStatus: __expectString(output.LastRunStatus),
        Name: __expectString(output.Name),
        NextInvocationTime: output.NextInvocationTime !== undefined && output.NextInvocationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.NextInvocationTime)))
            : undefined,
        PreviousInvocationTime: output.PreviousInvocationTime !== undefined && output.PreviousInvocationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.PreviousInvocationTime)))
            : undefined,
        State: __expectString(output.State),
        TargetDestination: output.TargetDestination !== undefined && output.TargetDestination !== null
            ? deserializeAws_json1_0TargetDestination(output.TargetDestination, context)
            : undefined,
    };
};
var deserializeAws_json1_0ScheduledQueryDescription = function (output, context) {
    return {
        Arn: __expectString(output.Arn),
        CreationTime: output.CreationTime !== undefined && output.CreationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.CreationTime)))
            : undefined,
        ErrorReportConfiguration: output.ErrorReportConfiguration !== undefined && output.ErrorReportConfiguration !== null
            ? deserializeAws_json1_0ErrorReportConfiguration(output.ErrorReportConfiguration, context)
            : undefined,
        KmsKeyId: __expectString(output.KmsKeyId),
        LastRunSummary: output.LastRunSummary !== undefined && output.LastRunSummary !== null
            ? deserializeAws_json1_0ScheduledQueryRunSummary(output.LastRunSummary, context)
            : undefined,
        Name: __expectString(output.Name),
        NextInvocationTime: output.NextInvocationTime !== undefined && output.NextInvocationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.NextInvocationTime)))
            : undefined,
        NotificationConfiguration: output.NotificationConfiguration !== undefined && output.NotificationConfiguration !== null
            ? deserializeAws_json1_0NotificationConfiguration(output.NotificationConfiguration, context)
            : undefined,
        PreviousInvocationTime: output.PreviousInvocationTime !== undefined && output.PreviousInvocationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.PreviousInvocationTime)))
            : undefined,
        QueryString: __expectString(output.QueryString),
        RecentlyFailedRuns: output.RecentlyFailedRuns !== undefined && output.RecentlyFailedRuns !== null
            ? deserializeAws_json1_0ScheduledQueryRunSummaryList(output.RecentlyFailedRuns, context)
            : undefined,
        ScheduleConfiguration: output.ScheduleConfiguration !== undefined && output.ScheduleConfiguration !== null
            ? deserializeAws_json1_0ScheduleConfiguration(output.ScheduleConfiguration, context)
            : undefined,
        ScheduledQueryExecutionRoleArn: __expectString(output.ScheduledQueryExecutionRoleArn),
        State: __expectString(output.State),
        TargetConfiguration: output.TargetConfiguration !== undefined && output.TargetConfiguration !== null
            ? deserializeAws_json1_0TargetConfiguration(output.TargetConfiguration, context)
            : undefined,
    };
};
var deserializeAws_json1_0ScheduledQueryList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ScheduledQuery(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0ScheduledQueryRunSummary = function (output, context) {
    return {
        ErrorReportLocation: output.ErrorReportLocation !== undefined && output.ErrorReportLocation !== null
            ? deserializeAws_json1_0ErrorReportLocation(output.ErrorReportLocation, context)
            : undefined,
        ExecutionStats: output.ExecutionStats !== undefined && output.ExecutionStats !== null
            ? deserializeAws_json1_0ExecutionStats(output.ExecutionStats, context)
            : undefined,
        FailureReason: __expectString(output.FailureReason),
        InvocationTime: output.InvocationTime !== undefined && output.InvocationTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.InvocationTime)))
            : undefined,
        RunStatus: __expectString(output.RunStatus),
        TriggerTime: output.TriggerTime !== undefined && output.TriggerTime !== null
            ? __expectNonNull(__parseEpochTimestamp(__expectNumber(output.TriggerTime)))
            : undefined,
    };
};
var deserializeAws_json1_0ScheduledQueryRunSummaryList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0ScheduledQueryRunSummary(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0SelectColumn = function (output, context) {
    return {
        Aliased: __expectBoolean(output.Aliased),
        DatabaseName: __expectString(output.DatabaseName),
        Name: __expectString(output.Name),
        TableName: __expectString(output.TableName),
        Type: output.Type !== undefined && output.Type !== null ? deserializeAws_json1_0Type(output.Type, context) : undefined,
    };
};
var deserializeAws_json1_0SelectColumnList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0SelectColumn(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0ServiceQuotaExceededException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0SnsConfiguration = function (output, context) {
    return {
        TopicArn: __expectString(output.TopicArn),
    };
};
var deserializeAws_json1_0Tag = function (output, context) {
    return {
        Key: __expectString(output.Key),
        Value: __expectString(output.Value),
    };
};
var deserializeAws_json1_0TagList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0Tag(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0TagResourceResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_0TargetConfiguration = function (output, context) {
    return {
        TimestreamConfiguration: output.TimestreamConfiguration !== undefined && output.TimestreamConfiguration !== null
            ? deserializeAws_json1_0TimestreamConfiguration(output.TimestreamConfiguration, context)
            : undefined,
    };
};
var deserializeAws_json1_0TargetDestination = function (output, context) {
    return {
        TimestreamDestination: output.TimestreamDestination !== undefined && output.TimestreamDestination !== null
            ? deserializeAws_json1_0TimestreamDestination(output.TimestreamDestination, context)
            : undefined,
    };
};
var deserializeAws_json1_0ThrottlingException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeAws_json1_0TimeSeriesDataPoint = function (output, context) {
    return {
        Time: __expectString(output.Time),
        Value: output.Value !== undefined && output.Value !== null
            ? deserializeAws_json1_0Datum(output.Value, context)
            : undefined,
    };
};
var deserializeAws_json1_0TimeSeriesDataPointList = function (output, context) {
    var retVal = (output || [])
        .filter(function (e) { return e != null; })
        .map(function (entry) {
        if (entry === null) {
            return null;
        }
        return deserializeAws_json1_0TimeSeriesDataPoint(entry, context);
    });
    return retVal;
};
var deserializeAws_json1_0TimestreamConfiguration = function (output, context) {
    return {
        DatabaseName: __expectString(output.DatabaseName),
        DimensionMappings: output.DimensionMappings !== undefined && output.DimensionMappings !== null
            ? deserializeAws_json1_0DimensionMappingList(output.DimensionMappings, context)
            : undefined,
        MeasureNameColumn: __expectString(output.MeasureNameColumn),
        MixedMeasureMappings: output.MixedMeasureMappings !== undefined && output.MixedMeasureMappings !== null
            ? deserializeAws_json1_0MixedMeasureMappingList(output.MixedMeasureMappings, context)
            : undefined,
        MultiMeasureMappings: output.MultiMeasureMappings !== undefined && output.MultiMeasureMappings !== null
            ? deserializeAws_json1_0MultiMeasureMappings(output.MultiMeasureMappings, context)
            : undefined,
        TableName: __expectString(output.TableName),
        TimeColumn: __expectString(output.TimeColumn),
    };
};
var deserializeAws_json1_0TimestreamDestination = function (output, context) {
    return {
        DatabaseName: __expectString(output.DatabaseName),
        TableName: __expectString(output.TableName),
    };
};
var deserializeAws_json1_0Type = function (output, context) {
    return {
        ArrayColumnInfo: output.ArrayColumnInfo !== undefined && output.ArrayColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfo(output.ArrayColumnInfo, context)
            : undefined,
        RowColumnInfo: output.RowColumnInfo !== undefined && output.RowColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfoList(output.RowColumnInfo, context)
            : undefined,
        ScalarType: __expectString(output.ScalarType),
        TimeSeriesMeasureValueColumnInfo: output.TimeSeriesMeasureValueColumnInfo !== undefined && output.TimeSeriesMeasureValueColumnInfo !== null
            ? deserializeAws_json1_0ColumnInfo(output.TimeSeriesMeasureValueColumnInfo, context)
            : undefined,
    };
};
var deserializeAws_json1_0UntagResourceResponse = function (output, context) {
    return {};
};
var deserializeAws_json1_0ValidationException = function (output, context) {
    return {
        Message: __expectString(output.Message),
    };
};
var deserializeMetadata = function (output) {
    var _a;
    return ({
        httpStatusCode: output.statusCode,
        requestId: (_a = output.headers["x-amzn-requestid"]) !== null && _a !== void 0 ? _a : output.headers["x-amzn-request-id"],
        extendedRequestId: output.headers["x-amz-id-2"],
        cfId: output.headers["x-amz-cf-id"],
    });
};
var collectBody = function (streamBody, context) {
    if (streamBody === void 0) { streamBody = new Uint8Array(); }
    if (streamBody instanceof Uint8Array) {
        return Promise.resolve(streamBody);
    }
    return context.streamCollector(streamBody) || Promise.resolve(new Uint8Array());
};
var collectBodyString = function (streamBody, context) {
    return collectBody(streamBody, context).then(function (body) { return context.utf8Encoder(body); });
};
var buildHttpRpcRequest = function (context, headers, path, resolvedHostname, body) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, hostname, _b, protocol, port, basePath, contents;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0: return [4, context.endpoint()];
            case 1:
                _a = _c.sent(), hostname = _a.hostname, _b = _a.protocol, protocol = _b === void 0 ? "https" : _b, port = _a.port, basePath = _a.path;
                contents = {
                    protocol: protocol,
                    hostname: hostname,
                    port: port,
                    method: "POST",
                    path: basePath.endsWith("/") ? basePath.slice(0, -1) + path : basePath + path,
                    headers: headers,
                };
                if (resolvedHostname !== undefined) {
                    contents.hostname = resolvedHostname;
                }
                if (body !== undefined) {
                    contents.body = body;
                }
                return [2, new __HttpRequest(contents)];
        }
    });
}); };
var parseBody = function (streamBody, context) {
    return collectBodyString(streamBody, context).then(function (encoded) {
        if (encoded.length) {
            return JSON.parse(encoded);
        }
        return {};
    });
};
var loadRestJsonErrorCode = function (output, data) {
    var findKey = function (object, key) { return Object.keys(object).find(function (k) { return k.toLowerCase() === key.toLowerCase(); }); };
    var sanitizeErrorCode = function (rawValue) {
        var cleanValue = rawValue;
        if (cleanValue.indexOf(":") >= 0) {
            cleanValue = cleanValue.split(":")[0];
        }
        if (cleanValue.indexOf("#") >= 0) {
            cleanValue = cleanValue.split("#")[1];
        }
        return cleanValue;
    };
    var headerKey = findKey(output.headers, "x-amzn-errortype");
    if (headerKey !== undefined) {
        return sanitizeErrorCode(output.headers[headerKey]);
    }
    if (data.code !== undefined) {
        return sanitizeErrorCode(data.code);
    }
    if (data["__type"] !== undefined) {
        return sanitizeErrorCode(data["__type"]);
    }
    return "";
};
