import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DeleteScheduledQueryRequest } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface DeleteScheduledQueryCommandInput extends DeleteScheduledQueryRequest {
}
export interface DeleteScheduledQueryCommandOutput extends __MetadataBearer {
}
/**
 * <p>Deletes a given scheduled query. This is an irreversible operation. </p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { TimestreamQueryClient, DeleteScheduledQueryCommand } from "@aws-sdk/client-timestream-query"; // ES Modules import
 * // const { TimestreamQueryClient, DeleteScheduledQueryCommand } = require("@aws-sdk/client-timestream-query"); // CommonJS import
 * const client = new TimestreamQueryClient(config);
 * const command = new DeleteScheduledQueryCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link DeleteScheduledQueryCommandInput} for command's `input` shape.
 * @see {@link DeleteScheduledQueryCommandOutput} for command's `response` shape.
 * @see {@link TimestreamQueryClientResolvedConfig | config} for TimestreamQueryClient's `config` shape.
 *
 */
export declare class DeleteScheduledQueryCommand extends $Command<DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: DeleteScheduledQueryCommandInput;
    constructor(input: DeleteScheduledQueryCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
