import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { UpdateScheduledQueryRequest } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface UpdateScheduledQueryCommandInput extends UpdateScheduledQueryRequest {
}
export interface UpdateScheduledQueryCommandOutput extends __MetadataBearer {
}
/**
 * <p>Update a scheduled query.</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { TimestreamQueryClient, UpdateScheduledQueryCommand } from "@aws-sdk/client-timestream-query"; // ES Modules import
 * // const { TimestreamQueryClient, UpdateScheduledQueryCommand } = require("@aws-sdk/client-timestream-query"); // CommonJS import
 * const client = new TimestreamQueryClient(config);
 * const command = new UpdateScheduledQueryCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link UpdateScheduledQueryCommandInput} for command's `input` shape.
 * @see {@link UpdateScheduledQueryCommandOutput} for command's `response` shape.
 * @see {@link TimestreamQueryClientResolvedConfig | config} for TimestreamQueryClient's `config` shape.
 *
 */
export declare class UpdateScheduledQueryCommand extends $Command<UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: UpdateScheduledQueryCommandInput;
    constructor(input: UpdateScheduledQueryCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
