import { HttpHandlerOptions as __HttpHandlerOptions } from "@aws-sdk/types";
import { CancelQueryCommandInput, CancelQueryCommandOutput } from "./commands/CancelQueryCommand";
import { CreateScheduledQueryCommandInput, CreateScheduledQueryCommandOutput } from "./commands/CreateScheduledQueryCommand";
import { DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput } from "./commands/DeleteScheduledQueryCommand";
import { DescribeEndpointsCommandInput, DescribeEndpointsCommandOutput } from "./commands/DescribeEndpointsCommand";
import { DescribeScheduledQueryCommandInput, DescribeScheduledQueryCommandOutput } from "./commands/DescribeScheduledQueryCommand";
import { ExecuteScheduledQueryCommandInput, ExecuteScheduledQueryCommandOutput } from "./commands/ExecuteScheduledQueryCommand";
import { ListScheduledQueriesCommandInput, ListScheduledQueriesCommandOutput } from "./commands/ListScheduledQueriesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "./commands/ListTagsForResourceCommand";
import { PrepareQueryCommandInput, PrepareQueryCommandOutput } from "./commands/PrepareQueryCommand";
import { QueryCommandInput, QueryCommandOutput } from "./commands/QueryCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "./commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "./commands/UntagResourceCommand";
import { UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput } from "./commands/UpdateScheduledQueryCommand";
import { TimestreamQueryClient } from "./TimestreamQueryClient";

export declare class TimestreamQuery extends TimestreamQueryClient {
    
    cancelQuery(args: CancelQueryCommandInput, options?: __HttpHandlerOptions): Promise<CancelQueryCommandOutput>;
    cancelQuery(args: CancelQueryCommandInput, cb: (err: any, data?: CancelQueryCommandOutput) => void): void;
    cancelQuery(args: CancelQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: CancelQueryCommandOutput) => void): void;
    
    createScheduledQuery(args: CreateScheduledQueryCommandInput, options?: __HttpHandlerOptions): Promise<CreateScheduledQueryCommandOutput>;
    createScheduledQuery(args: CreateScheduledQueryCommandInput, cb: (err: any, data?: CreateScheduledQueryCommandOutput) => void): void;
    createScheduledQuery(args: CreateScheduledQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: CreateScheduledQueryCommandOutput) => void): void;
    
    deleteScheduledQuery(args: DeleteScheduledQueryCommandInput, options?: __HttpHandlerOptions): Promise<DeleteScheduledQueryCommandOutput>;
    deleteScheduledQuery(args: DeleteScheduledQueryCommandInput, cb: (err: any, data?: DeleteScheduledQueryCommandOutput) => void): void;
    deleteScheduledQuery(args: DeleteScheduledQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DeleteScheduledQueryCommandOutput) => void): void;
    
    describeEndpoints(args: DescribeEndpointsCommandInput, options?: __HttpHandlerOptions): Promise<DescribeEndpointsCommandOutput>;
    describeEndpoints(args: DescribeEndpointsCommandInput, cb: (err: any, data?: DescribeEndpointsCommandOutput) => void): void;
    describeEndpoints(args: DescribeEndpointsCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DescribeEndpointsCommandOutput) => void): void;
    
    describeScheduledQuery(args: DescribeScheduledQueryCommandInput, options?: __HttpHandlerOptions): Promise<DescribeScheduledQueryCommandOutput>;
    describeScheduledQuery(args: DescribeScheduledQueryCommandInput, cb: (err: any, data?: DescribeScheduledQueryCommandOutput) => void): void;
    describeScheduledQuery(args: DescribeScheduledQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: DescribeScheduledQueryCommandOutput) => void): void;
    
    executeScheduledQuery(args: ExecuteScheduledQueryCommandInput, options?: __HttpHandlerOptions): Promise<ExecuteScheduledQueryCommandOutput>;
    executeScheduledQuery(args: ExecuteScheduledQueryCommandInput, cb: (err: any, data?: ExecuteScheduledQueryCommandOutput) => void): void;
    executeScheduledQuery(args: ExecuteScheduledQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: ExecuteScheduledQueryCommandOutput) => void): void;
    
    listScheduledQueries(args: ListScheduledQueriesCommandInput, options?: __HttpHandlerOptions): Promise<ListScheduledQueriesCommandOutput>;
    listScheduledQueries(args: ListScheduledQueriesCommandInput, cb: (err: any, data?: ListScheduledQueriesCommandOutput) => void): void;
    listScheduledQueries(args: ListScheduledQueriesCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: ListScheduledQueriesCommandOutput) => void): void;
    
    listTagsForResource(args: ListTagsForResourceCommandInput, options?: __HttpHandlerOptions): Promise<ListTagsForResourceCommandOutput>;
    listTagsForResource(args: ListTagsForResourceCommandInput, cb: (err: any, data?: ListTagsForResourceCommandOutput) => void): void;
    listTagsForResource(args: ListTagsForResourceCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: ListTagsForResourceCommandOutput) => void): void;
    
    prepareQuery(args: PrepareQueryCommandInput, options?: __HttpHandlerOptions): Promise<PrepareQueryCommandOutput>;
    prepareQuery(args: PrepareQueryCommandInput, cb: (err: any, data?: PrepareQueryCommandOutput) => void): void;
    prepareQuery(args: PrepareQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: PrepareQueryCommandOutput) => void): void;
    
    query(args: QueryCommandInput, options?: __HttpHandlerOptions): Promise<QueryCommandOutput>;
    query(args: QueryCommandInput, cb: (err: any, data?: QueryCommandOutput) => void): void;
    query(args: QueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: QueryCommandOutput) => void): void;
    
    tagResource(args: TagResourceCommandInput, options?: __HttpHandlerOptions): Promise<TagResourceCommandOutput>;
    tagResource(args: TagResourceCommandInput, cb: (err: any, data?: TagResourceCommandOutput) => void): void;
    tagResource(args: TagResourceCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: TagResourceCommandOutput) => void): void;
    
    untagResource(args: UntagResourceCommandInput, options?: __HttpHandlerOptions): Promise<UntagResourceCommandOutput>;
    untagResource(args: UntagResourceCommandInput, cb: (err: any, data?: UntagResourceCommandOutput) => void): void;
    untagResource(args: UntagResourceCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: UntagResourceCommandOutput) => void): void;
    
    updateScheduledQuery(args: UpdateScheduledQueryCommandInput, options?: __HttpHandlerOptions): Promise<UpdateScheduledQueryCommandOutput>;
    updateScheduledQuery(args: UpdateScheduledQueryCommandInput, cb: (err: any, data?: UpdateScheduledQueryCommandOutput) => void): void;
    updateScheduledQuery(args: UpdateScheduledQueryCommandInput, options: __HttpHandlerOptions, cb: (err: any, data?: UpdateScheduledQueryCommandOutput) => void): void;
}
