import { EndpointsInputConfig, EndpointsResolvedConfig, RegionInputConfig, RegionResolvedConfig } from "@aws-sdk/config-resolver";
import { EndpointDiscoveryInputConfig, EndpointDiscoveryResolvedConfig } from "@aws-sdk/middleware-endpoint-discovery";
import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { RetryInputConfig, RetryResolvedConfig } from "@aws-sdk/middleware-retry";
import { AwsAuthInputConfig, AwsAuthResolvedConfig } from "@aws-sdk/middleware-signing";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { HttpHandler as __HttpHandler } from "@aws-sdk/protocol-http";
import { Client as __Client, DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@aws-sdk/smithy-client";
import { BodyLengthCalculator as __BodyLengthCalculator, Credentials as __Credentials, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, RegionInfoProvider, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@aws-sdk/types";
import { CancelQueryCommandInput, CancelQueryCommandOutput } from "./commands/CancelQueryCommand";
import { CreateScheduledQueryCommandInput, CreateScheduledQueryCommandOutput } from "./commands/CreateScheduledQueryCommand";
import { DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput } from "./commands/DeleteScheduledQueryCommand";
import { DescribeEndpointsCommandInput, DescribeEndpointsCommandOutput } from "./commands/DescribeEndpointsCommand";
import { DescribeScheduledQueryCommandInput, DescribeScheduledQueryCommandOutput } from "./commands/DescribeScheduledQueryCommand";
import { ExecuteScheduledQueryCommandInput, ExecuteScheduledQueryCommandOutput } from "./commands/ExecuteScheduledQueryCommand";
import { ListScheduledQueriesCommandInput, ListScheduledQueriesCommandOutput } from "./commands/ListScheduledQueriesCommand";
import { ListTagsForResourceCommandInput, ListTagsForResourceCommandOutput } from "./commands/ListTagsForResourceCommand";
import { PrepareQueryCommandInput, PrepareQueryCommandOutput } from "./commands/PrepareQueryCommand";
import { QueryCommandInput, QueryCommandOutput } from "./commands/QueryCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "./commands/TagResourceCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "./commands/UntagResourceCommand";
import { UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput } from "./commands/UpdateScheduledQueryCommand";
export declare type ServiceInputTypes = CancelQueryCommandInput | CreateScheduledQueryCommandInput | DeleteScheduledQueryCommandInput | DescribeEndpointsCommandInput | DescribeScheduledQueryCommandInput | ExecuteScheduledQueryCommandInput | ListScheduledQueriesCommandInput | ListTagsForResourceCommandInput | PrepareQueryCommandInput | QueryCommandInput | TagResourceCommandInput | UntagResourceCommandInput | UpdateScheduledQueryCommandInput;
export declare type ServiceOutputTypes = CancelQueryCommandOutput | CreateScheduledQueryCommandOutput | DeleteScheduledQueryCommandOutput | DescribeEndpointsCommandOutput | DescribeScheduledQueryCommandOutput | ExecuteScheduledQueryCommandOutput | ListScheduledQueriesCommandOutput | ListTagsForResourceCommandOutput | PrepareQueryCommandOutput | QueryCommandOutput | TagResourceCommandOutput | UntagResourceCommandOutput | UpdateScheduledQueryCommandOutput;
export interface ClientDefaults extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
    
    requestHandler?: __HttpHandler;
    
    sha256?: __HashConstructor;
    
    urlParser?: __UrlParser;
    
    bodyLengthChecker?: __BodyLengthCalculator;
    
    streamCollector?: __StreamCollector;
    
    base64Decoder?: __Decoder;
    
    base64Encoder?: __Encoder;
    
    utf8Decoder?: __Decoder;
    
    utf8Encoder?: __Encoder;
    
    runtime?: string;
    
    disableHostPrefix?: boolean;
    
    maxAttempts?: number | __Provider<number>;
    
    retryMode?: string | __Provider<string>;
    
    logger?: __Logger;
    
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    
    useFipsEndpoint?: boolean | __Provider<boolean>;
    
    serviceId?: string;
    
    region?: string | __Provider<string>;
    
    credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
    
    regionInfoProvider?: RegionInfoProvider;
    
    defaultUserAgentProvider?: Provider<__UserAgent>;
    
    endpointDiscoveryEnabledProvider?: __Provider<boolean | undefined>;
    
    defaultsMode?: DefaultsMode | Provider<DefaultsMode>;
}
declare type TimestreamQueryClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & RegionInputConfig & EndpointsInputConfig & RetryInputConfig & HostHeaderInputConfig & AwsAuthInputConfig & UserAgentInputConfig & EndpointDiscoveryInputConfig;

export interface TimestreamQueryClientConfig extends TimestreamQueryClientConfigType {
}
declare type TimestreamQueryClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RegionResolvedConfig & EndpointsResolvedConfig & RetryResolvedConfig & HostHeaderResolvedConfig & AwsAuthResolvedConfig & UserAgentResolvedConfig & EndpointDiscoveryResolvedConfig;

export interface TimestreamQueryClientResolvedConfig extends TimestreamQueryClientResolvedConfigType {
}

export declare class TimestreamQueryClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig> {
    
    readonly config: TimestreamQueryClientResolvedConfig;
    constructor(configuration: TimestreamQueryClientConfig);
    
    destroy(): void;
}
export {};
