import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CreateScheduledQueryRequest, CreateScheduledQueryResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface CreateScheduledQueryCommandInput extends CreateScheduledQueryRequest {
}
export interface CreateScheduledQueryCommandOutput extends CreateScheduledQueryResponse, __MetadataBearer {
}

export declare class CreateScheduledQueryCommand extends $Command<CreateScheduledQueryCommandInput, CreateScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: CreateScheduledQueryCommandInput;
    constructor(input: CreateScheduledQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<CreateScheduledQueryCommandInput, CreateScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
