import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DeleteScheduledQueryRequest } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface DeleteScheduledQueryCommandInput extends DeleteScheduledQueryRequest {
}
export interface DeleteScheduledQueryCommandOutput extends __MetadataBearer {
}

export declare class DeleteScheduledQueryCommand extends $Command<DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: DeleteScheduledQueryCommandInput;
    constructor(input: DeleteScheduledQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DeleteScheduledQueryCommandInput, DeleteScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
