import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { DescribeScheduledQueryRequest, DescribeScheduledQueryResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface DescribeScheduledQueryCommandInput extends DescribeScheduledQueryRequest {
}
export interface DescribeScheduledQueryCommandOutput extends DescribeScheduledQueryResponse, __MetadataBearer {
}

export declare class DescribeScheduledQueryCommand extends $Command<DescribeScheduledQueryCommandInput, DescribeScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: DescribeScheduledQueryCommandInput;
    constructor(input: DescribeScheduledQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeScheduledQueryCommandInput, DescribeScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
