import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ExecuteScheduledQueryRequest } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface ExecuteScheduledQueryCommandInput extends ExecuteScheduledQueryRequest {
}
export interface ExecuteScheduledQueryCommandOutput extends __MetadataBearer {
}

export declare class ExecuteScheduledQueryCommand extends $Command<ExecuteScheduledQueryCommandInput, ExecuteScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: ExecuteScheduledQueryCommandInput;
    constructor(input: ExecuteScheduledQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ExecuteScheduledQueryCommandInput, ExecuteScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
