import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ListScheduledQueriesRequest, ListScheduledQueriesResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface ListScheduledQueriesCommandInput extends ListScheduledQueriesRequest {
}
export interface ListScheduledQueriesCommandOutput extends ListScheduledQueriesResponse, __MetadataBearer {
}

export declare class ListScheduledQueriesCommand extends $Command<ListScheduledQueriesCommandInput, ListScheduledQueriesCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: ListScheduledQueriesCommandInput;
    constructor(input: ListScheduledQueriesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListScheduledQueriesCommandInput, ListScheduledQueriesCommandOutput>;
    private serialize;
    private deserialize;
}
