import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { PrepareQueryRequest, PrepareQueryResponse } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface PrepareQueryCommandInput extends PrepareQueryRequest {
}
export interface PrepareQueryCommandOutput extends PrepareQueryResponse, __MetadataBearer {
}

export declare class PrepareQueryCommand extends $Command<PrepareQueryCommandInput, PrepareQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: PrepareQueryCommandInput;
    constructor(input: PrepareQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<PrepareQueryCommandInput, PrepareQueryCommandOutput>;
    private serialize;
    private deserialize;
}
