import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { UpdateScheduledQueryRequest } from "../models/models_0";
import { ServiceInputTypes, ServiceOutputTypes, TimestreamQueryClientResolvedConfig } from "../TimestreamQueryClient";
export interface UpdateScheduledQueryCommandInput extends UpdateScheduledQueryRequest {
}
export interface UpdateScheduledQueryCommandOutput extends __MetadataBearer {
}

export declare class UpdateScheduledQueryCommand extends $Command<UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput, TimestreamQueryClientResolvedConfig> {
    readonly input: UpdateScheduledQueryCommandInput;
    constructor(input: UpdateScheduledQueryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: TimestreamQueryClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdateScheduledQueryCommandInput, UpdateScheduledQueryCommandOutput>;
    private serialize;
    private deserialize;
}
